import java.util.*;

// Represents a segmented line
public class Line implements Graphable {
    private Set<Point> points;

    // Constructs a new line
    public Line() {
        this.points = new TreeSet<>();
    }

    // Adds the given Point 'p' to this line, inserting it at the appropriate spot
    public void addPoint(Point p) {
        this.points.add(p);
    }

    // Returns the total number of points within the line
    public int getNumPoints() {
        return points.size();
    }

    // Returns this line as a list of points
    public List<Point> getPoints() {
        return new ArrayList<>(this.points);
    }

    // Returns whether or not this Line is equal to the provided 'other' Object
    @Override
    public boolean equals(Object other) {
        if (other == null || !(other instanceof Line)) {
            return false;
        } else {
            return ((Line)other).getPoints().equals(getPoints());
        }
    }
}
